# 使用Nano Code调试GDK8上的程序
Nano Code是GDK系列调试套件的配套软件，集成了Nano Debugger、Nano Read、Nano Course、Nano Bell四个子系统，从高级调试、技术问答、知识储备等多方面对传统IDE进行扩展，旨在为专业程序员提供专业的开发环境。Nano Code的前端使用Node.JS技术开发，具有速度快、易扩展、阔平台等多种优势。
## 主要步骤：
1. 编写一个hello world的小程序。

```c
#include <stdio.h>

int main(int argc, char *argv[])
{
	printf("Hello, Geduer\n");

	return 0;
}
```
2. 编译程序。

```c
gcc -g -o hello_world hello_world.c
```
3. 使用Nano Code连接GDK8（参考[GDK8上手指南](https://www.nanocode.cn/wiki/docs/gdk8_primer "GDK8上手指南")）。
4. 点击文件->打开可执行文件->设置好相应信息->点击开始。
第一行：tcp:port=2021,server=<IP地址>
第二行：命令行参数
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_ffedcffb722fef862890fee4b86ab54a_r.png)
5. 此时就可以看到程序在执行的起点处停住了。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_9890f4bcd887069ecadb238befcab483_r.png)
6. 通过bp命令设置断点。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_3bf938301e43b82e58faf9809c0aaae1_r.png)
7. 输入g命令等待断点命中。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_6a614fea5fdc4e5cdb32d33834ff977e_r.png)
8. 断点命中。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_237535b2e6d20f643b321a55c10b0801_r.png)
9. 以上就是调试一个程序的初始步骤，您可以结合Nano Code继续深入调试；从而脱离GDB命令行的苦海，开启图形化界面调试的畅快体验。