# 构建安卓编译环境
**环境：Ubuntu 18.04**
**需要内存：16GB**
## 1. 下载安卓编译环境
链接: https://pan.baidu.com/s/1VZ80lmtMVzxJhuYW8wOx6Q 提取码: 6q8x
## 2. 下载工具
```c
apt-get install python3 make gcc git gcc-aarch64-linux-gnu bison flex libssl-dev
```
## 3. 源代码准备
1. 源代码，放在system目录下即可。

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_c929825ca302c0860c57ffc16594c1b7_r.png)
2. Android.bp文件。

```c
基本格式为：
cc_binary {
	name:"",
	srcs:[],
	cflags:[],
	shared_libs:[]
}

参考：https://source.android.google.cn/docs/setup/build?hl=zh-cn
```

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_83d993e5c9f116c3715fa7d65d06ddb9_r.png)
3. 名字添加到*.mk（如base_system.mk base_vendor.mk）

```c
*.mk路径：build/target/product/
在PRODUCT_PACKAGES += \下添加name，Android.bp中填写的name
```
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_59153a73a9f068e84a5e8cd93d5c26cb_r.png)

## 4. 编译
`./build_android.sh`

编译出来的文件，可以在out/target/product/rk3328_box/system/bin下找到。