不少同学想要通过Nano Code调试GDK8上面的用户态程序，在这个时候就需要ndstub的帮助，但是可能有的同学gdk8上面ndstub并没有启用，因此本文会介绍一下如何在gdk8上运行ndstub。

# 1. 正常运行

可以通过`sudo /opt/gedu/ndstub`运行ndstub，此时可以直接运行ndstub，并在命令行内看到打印的日志信息。

```
sudo /opt/gedu/ndstub
Stub process for Nano Debugger(ARM64-LINUX), rev. 2.0.2022 (pid=1039)
log file: /var/log/ndstub1.log
0714151847I#1039:-log file (/var/log/ndstub1.log) created.
0714151847I#1039:Global options 0x4
```

# 2. 后台服务运行

可以通过`sudo /opt/gedu/ndstub -s`命令让ndstub作为后台服务运行，可以在命令行内看到ndstub将日志打印到何处。

```
sudo /opt/gedu/ndstub -s
Stub process for Nano Debugger(ARM64-LINUX), rev. 2.0.2022 (pid=1055)
log file: /var/log/ndstub1.log
0714153019I#1055:-log file (/var/log/ndstub1.log) created.

ps -A | grep ndstub
 1056 pts/0    00:00:00 ndstub
```

# 帮助信息

可以通过`sudo /opt/gedu/ndstub -h`命令，查看ndstub的使用帮助。

```
sudo /opt/gedu/ndstub -h
Stub process for Nano Debugger(ARM64-LINUX), rev. 2.0.2022 (pid=1052)
log file: /var/log/ndstub1.log
0714153010I#1052:-log file (/var/log/ndstub1.log) created.
ndstub: welcome
usage: ndstub [options]
        -t <transport> -l <loglevel> [-m dbgmasks]
                transport can be: tcp[:port=<portno>]
        -d|e <addr> to read/write physical memory
        -c <cmdline> [args...]]
        -m dbgmasks:
         xme
         dbgdbg
        -h/? to show this help.
        For example: ndstub -t tcp:port=2021
```