##### 你可以使用一些命令行工具来启动 JTAG 并查看 JTAG 运行状态。具体的命令可能因不同的 JTAG 调试工具和硬件平台而有所不同。下面是一些常用的命令示例：

1. JTAG 启动命令：
   - 对于 OpenOCD：
     ```
     openocd -f <配置文件>
     ```
   - 对于 J-Link：
     ```
     JLinkGDBServer -if <接口> -device <设备>
     ```
   - 对于 Xilinx Vivado TCL Shell：
     ```
     open_hw
     connect_hw_server
     open_hw_target -i <接口> -c <控制器>
     ```
   - 对于其他 JTAG 调试工具，请参考其文档或说明。

2. 查看 JTAG 运行状态的命令：
   - 对于 OpenOCD：
     ```
     telnet localhost <telnet 端口号>
     > poll
     ```
   - 对于 J-Link GDB Server：
     ```
     telnet localhost <telnet 端口号>
     > IsHalted
     > Registers
     ```
   - 对于 Xilinx Vivado TCL Shell：
     ```
     current_hw_target
     current_hw_device
     ```

请注意，命令的确切形式和参数取决于你使用的 JTAG 调试工具和硬件平台。因此，你需要根据你的具体情况进行适当调整。还请确保在执行任何 JTAG 操作之前，详细阅读相关文档和手册，以确保正确的用法和配置。