# 使用GDK8进行内核调试
使用NanoCode与GDK8进行内核调试需要与格蠹另一套产品**挥码枪**配套使用

------------
挥码枪的相关wiki链接：https://www.nanocode.cn/wiki/docs/gedu_ntp_wiki

## 主要步骤：
### 1 硬件准备

------------

###### 1.1 将SD卡与挥码枪连接
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_e15817ec4aca6c5cc571a16dbe139844_r.png)
###### 1.2 将转接卡插入GDK8，USB线连接连接挥码枪并插入上位机，整体连接情况如下图所示
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_fecc56831b02b40132925fda6d6cfc10_r.png)
###### 1.3 开启GDK8的JTAG，可以通过GDK8的葫芦娃小程序或者遥控器按[Fn+5]进行切换

------------

### 2 建立内核调试会话

------------

###### 2.1 进入NanoCode并连接到远端后进入Nano调试并选择内核调试，并按照下图进行参数配置
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_4f65a94815ca4c706cf44d2cbcae98e0_r.png)
###### 2.2 配置完毕后点击启动，出现下面界面后点击中断
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_6fa9d38545d22f3d0ac8ebcd1db6ce65_r.png)
###### 2.3 出现下列命令提示符后即表示内核调试会话建立成功
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_3a6197870ad68397bea58a0776afc6cc_r.png)

如遇挥码枪相关问题可以查阅这篇文章：https://www.nanocode.cn/wiki/docs/gedu_ntp_wiki/gedu_ntp_wiki-1dvrb4hmo8g25

------------

### 3 加载内核符号及源代码

------------

###### 3.1 下载内核符号及源代码
https://www.nanocode.cn/wiki/docs/gdk8_primer/gdk8_img_bom

在链接内下载这两个即可：**看实际需要下载的版本，是安卓还是ubuntu**

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_a0395e48a8b67f0c61190099762609ee_r.png)

###### 3.2 设置符号及源代码路径
```
.sympath + 路径 //设置符号文件所在的文件夹路径
.srcpath + 路径 //设置内核文件所在的文件夹路径
```
## 示例：
符号路径为**E:\gdk8\symbol**     下载的**vmlinux符号文件**就放在这个目录下。命令为：
```bash
.sympath+ E:\gdk8\symbol
```

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_1bf29de1b58c43e3244d389eb0387e19_r.png)

内核源代码路径为**E:\gdk8\source\**.  应包含下图相关文件,命令为```
.srcpath+ E:\gdk8\source\
```
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_6c72e919e1f7198a722daed0e917596e_r.PNG)



###### 3.3 使用.reload命令重新加载

.reload后如果顺利则可以看到源代码窗口自动弹出，此时即可对照着源代码进行内核调试

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_fc065c7e4ebc543fb07908fee94ae2ef_r.png)