# 使用SD卡启动GDK8
GDK8支持从两种存储设备（SD卡 / EMMC）中启动；默认情况下GDK8是从EMMC上启动的，因此我们会先[烧录固件](https://www.nanocode.cn/wiki/docs/gdk8_primer/primer_gdk8_firmware "烧录固件")，把固件烧到EMMC内的，然后给GDK8上电，这时GDK8就可以通过EMMC启动了。
假如想要通过SD卡启动GDK8，只需要把固件烧录到SD卡上面（CPU会判断能否可以从SD卡上面启动，能的话就会从SD卡上去启动，而不是使用EMMC启动）。
## 主要步骤：
1. 下载SD卡的烧录工具。
[SD卡烧录工具下载链接](https://www.nanocode.cn/software/gdk8/SD_Firmware_Tool_v1.59.zip "SD卡烧录工具下载链接")
2. 解压压缩包后运行SD_Firmware_Tool。
3. 找一张SD卡，并插入主机中（需要准备一个读卡器）。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_a8f3170d1e2d20df35139931adf2c1b1_r.png)
4. 在SD_Firmware_Tool内选择合适的选项。
第一步：选择可移动磁盘设备>>SD卡对应的存储设备名
第二步：选择功能模式>>SD启动
第三步：选择升级固件>>选择合适的固件
第四步：选择Demo数据>>不选（也可以根据自己的需要去选择）
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_179fa0d0bb072f5fdff5390078628c26_r.png)
**假如SD卡内有重要数据，记得备份一下；下面这步会进行格式化**
5. 点击开始创建，再点击是；然后等待烧录完成就行。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_0c162d012e22caa50afdf0ad2135c3b1_r.png)
6. 完成烧录之后，会提示“创建升级磁盘成功”，然后点击确定。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_fca630064181c8fd89783ca195943ab6_r.png)
7. 在使用SD卡启动之前，先确认系统信息，然后和通过SD卡启动的信息比对一下，以便核实GDK8是不是用SD卡启动的。
内核版本时间>>Dec 23 17:58:00
```c
Linux gdk8 4.4.179-yanzi #74 SMP Thu Dec 23 17:58:00 CST 2021 aarch64 aarch64 aarch64 GNU/Linux
```
没有GPU加速时出现的崩溃问题且正常使用docker
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_b0e9b65cbaa214bc24cb7cb602d648ed_r.png)
8. 将SD卡插入GDK8的卡槽内，给GDK8上电（第一次启动时，可能会出现roofs未更新的情况，此时只需再次重启即可）。
9. 进入桌面后，看一下系统信息，确认GDK8是不是用SD卡启动的。
内核版本时间>>Oct 31 18:00:59
```c
Linux gdk8 4.4.179-yanzi #6 SMP Sun Oct 31 18:00:59 CST 2021 aarch64 aarch64 aarch64 GNU/Linux
```
10. 此时GDK8就通过SD卡完成启动了。
**注意:SD卡作为启动卡后，会重写卡上的分区，如果想恢复SD卡的正常使用，可以点击SD_Firmware_Tool的恢复磁盘进行恢复。**