本次发布的镜像版本取名为奉贤，因为相传公元前444年，言子来到东海之滨开设学馆，不但教授弟子学文习字，更以儒学的礼仪教人育德。在言子的倡导下，海隅处处可闻礼乐之声，言子也被海隅百姓尊为“贤人”。

为纪念这位毕生致力于传学兴礼的贤人，后人将县名取为“奉贤”，建造了“言子祠”，以表达怀念之情，更彰显后人以言子为楷模，崇尚“敬奉贤人，见贤思齐”的民风。如今“敬贤、学贤、齐贤”已然成为奉贤市民的行为准则。

2023年9月28日，上海奉贤区言子书院启用仪式隆重举行。开阔的入口广场与言子雕塑，仿佛从城市步入了一处世外桃源和文化圣地。静谧的空间氛围沉淀参观者的心绪，引领人们踏上言子的讲学之路。

奉贤版本的新功能和改动如下。

## 主要改动
### 1. 改进u-boot（波特率需要设置为1500000）
- 支持SD串口功能，可以使用SD转接头和TTL-USB与另一台电脑建立串口通信。
- 支持进入u-boot命令行，先连接串口，然后在串口终端按热键11（两个1）

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_0f3c614215502a837153341dcfa5bd99_r.png)

### 2. 根文件系统升级到Ubuntu 24.04
这是目前最新的Ubuntu LTS版本
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_b2d9579961f71f5f80dcb3b18bb54505_r.png)
### 3. 默认启用了debuginfod
在gdb调试时，可以自动根据需要下载调试符号，
```c
geduer@gdk8:~$ gdb ls
This GDB supports auto-downloading debuginfo from the following URLs:
  <https://debuginfod.ubuntu.com>
Enable debuginfod for this session? (y or [n]) y
Debuginfod has been enabled.
To make this setting permanent, add 'set debuginfod enabled on' to .gdbinit.
Downloading separate debug info for /usr/bin/ls
Downloading separate debug info for /usr/bin/ls
Reading symbols from /home/geduer/.cache/debuginfod_client/fec30f5745c2582aaf143e7079d3bb46ca7a010f/debuginfo...
(gdb) b main
Downloading source file /usr/src/coreutils-9.4-3ubuntu6/src/ls.c
Breakpoint 1 at 0x3e80: file src/ls.c, line 1645.
(gdb) r
Starting program: /usr/bin/ls
Downloading separate debug info for system-supplied DSO at 0x7ff7ffb000
Downloading separate debug info for /lib/aarch64-linux-gnu/libselinux.so.1
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/aarch64-linux-gnu/libthread_db.so.1".
Downloading separate debug info for /lib/aarch64-linux-gnu/libpcre2-8.so.0

Breakpoint 1, main (argc=1, argv=0x7ffffff3a8) at src/ls.c:1645
1645    {
(gdb) l
1640      signal_setup (false);
1641    }
1642
1643    int
1644    main (int argc, char **argv)
1645    {
1646      int i;
1647      struct pending *thispend;
1648      int n_files;
1649
(gdb)

```
### 4. 增加内核选项
增加如下内核选项用于支持用户空间的命名空间
CONFIG_USER_NS 
但仍很好的支持内核调试。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_fd6406687f275c428309b9bb132cc985_r.png)