为了不断改进和丰富GDK8的功能和玩法，我们将对GDK8的软件栈做持续的更新和维护，包括uboot、Linux内核和根文件系统。 更新存在一定风险，请一定牢记在更新前，将你在GDK8上产生或者修改过的所有新文件做好备份，包括但不限于：
- 新创建或者修改过的源代码
- 各种文档
- 修改过的配置文件

# 一、Ubuntu
## 最新版本
#### 言子-奉贤2版本（2024年7月更新)

更新内容：
1. 恢复上一版奉贤缺少perf问题
2. 修复gelabs里面gemalloc编译出错问题
3. 修复gourdboy在上一版奉贤无法使用问题

下面可选**1.完整更新**和**2.单独更新**可以根据自己的实际情况进行选择，二选一即可。

##### 1.完整更新
奉贤2完整镜像下载链接：
https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian2/gdk8-fengxian2.zip        
该镜像需要再次更新下面链接的uboot才可以支持ylboot.ini参数启动

主要改动说明：
https://www.nanocode.cn/wiki/docs/gdk8_primer/fengxian2_update


下载源代码：
内核：https://github.com/gedulab/gdk8k

##### 2.单独更新 
如果不想完整更新，需要单独更新的话，可以参考第三部分的更新方法，对内核及 uboot 进行更新。

单独更新uboot相关文件（包含符号文件）:
https://www.nanocode.cn/wiki/docs/gdk8_primer/gdk8_uboot

单独更新内核文件：
https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian2/fx2_rel.zip

内核符号文件下载链接：
https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian2/vmlinux


## 历史版本
#### 言子-奉贤版本（2024年5月更新)

更新内容：
1. 升级u-boot
支持SD串口功能
支持进入u-boot命令行，按键11
2. Ubuntu升级到24.04
3. 启用debuginfod

下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian1/gdk8-fengxian.zip

主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/fengxian_update
下载符号文件（**找到里面的vmlinux就是符号文件**）：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian1/symbols.tar.gz

下载源代码：
内核：https://github.com/gedulab/gdk8k

```
如果需要单独更新内核、uboot，可以使用下方的文件。

可单独更新的uboot及内核文件链接：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/FengXian1/imgs.tar.gz

内核及uboot的更新
1. 下载上面的文件，此文件仅包含 boot.img 和 uboot.img。
2. 参考第三部分的更新方法，对内核及 uboot 进行更新。
```

#### 言子-聊城4版本（2023年8月更新)
更新内容：修正启动阶段的调试支持，蓝牙模块与调试兼容
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_IMG/liaocheng4/liaocheng4.zip

主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/liaocheng_update
下载符号文件（**找到里面的vmlinux就是符号文件**）：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_IMG/liaocheng4/symbols.tar.gz

下载源代码：
内核链接：https://github.com/gedulab/gdk8k


```
对于聊城1版本的用户，如果想要使用蓝牙需要更新内核、uboot及内核头文件，不需要再更新完整的镜像。

内核及uboot的更新
1. 下载符号文件，找到boot.img及uboot.img。
2. 参考下面的更新方法，对内核及uboot进行更新。
内核头文件更新：
1. 下载内核头文件包。
2. sudo tar -zxvf linux-headers-4.19.161-yanzi.tar.gz -C /usr/src/linux-headers-4.19.161-yanzi/
```

```
如果想要编译驱动，需要将下面的补充包解压到GDK8上，具体解压命令如下。
补充包下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/generated.tar.gz

sudo tar -zxvf generated.tar.gz -C /usr/src/linux-headers-4.19.161-yanzi/
```

#### 言子-聊城3版本（2023年8月更新)
更新内容：修正启动阶段的调试支持
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_IMG/liaocheng3/GDK8UBUNTU.IMG-GPT-20230714-1757.zip

主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/liaocheng_update

下载符号文件：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_IMG/liaocheng3/liaocheng3.zip

下载源代码：
内核：https://github.com/gedulab/gdk8k



#### 言子-聊城2版本（2023年5月更新)

下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/liaocheng2.zip

主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/liaocheng_update

下载符号文件：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/symbols.zip

下载源代码：
内核：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/kernel.tar.gz
内核头文件：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/linux-headers-4.19.161-yanzi.tar.gz
U-Boot：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/u-boot.tar.gz

```
对于聊城1版本的用户，如果想要使用蓝牙需要更新内核、uboot及内核头文件，不需要再更新完整的镜像。

内核及uboot的更新
1. 下载符号文件，找到boot.img及uboot.img。
2. 参考下面的更新方法，对内核及uboot进行更新。
内核头文件更新：
1. 下载内核头文件包。
2. sudo tar -zxvf linux-headers-4.19.161-yanzi.tar.gz -C /usr/src/linux-headers-4.19.161-yanzi/
```

```
如果想要编译驱动，需要将下面的补充包解压到GDK8上，具体解压命令如下。
补充包下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK8/Release/Ubuntu/LiaoCheng2/generated.tar.gz

sudo tar -zxvf generated.tar.gz -C /usr/src/linux-headers-4.19.161-yanzi/
```

#### 言子-武城版本（2022年6月更新)

下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_IMG/GDK8UBUNTU.IMG-GPT-20220617-1836.img_wucheng2.7z
主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/img_wucheng

下载符号文件：https://gedu.oss-cn-beijing.aliyuncs.com/wucheng/vmlinux

下载内核源代码：https://github.com/gdk8/kernel

#### 言子-曲阜版本（2021年12月更新)

下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/%E8%A8%80%E5%AD%90-%E6%9B%B2%E9%98%9C/GDK8-YANZI-QUFU.zip

#### 言子-虞城版本（2021年1月初始版本）

下载链接：https://share.weiyun.com/56NtrKZ3
主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/primer_gdk8_newimg

# 二、安卓
## 最新版本
言子-武城3版本（2022年9月更新版本)

下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/android/wucheng3/update.zip
主要改动：https://www.nanocode.cn/wiki/docs/gdk8_primer/android_wucheng3

下载符号文件：
ramdisk: https://pan.baidu.com/s/14CWzMxJ1Cy9sQZaO8563PA 提取码: rx1j
system_ext: https://pan.baidu.com/s/18tbBAmI3biPZ7OrdJiduqA 提取码: b7gx
recovery: https://pan.baidu.com/s/1Vw8SZgc1tlyJhlrU7YnREQ 提取码: fvn9
testcases: https://pan.baidu.com/s/18fXhQjOUhe_izosgraVogw 提取码: 1wf2
data: https://pan.baidu.com/s/1RxQWlbDKc56HG28l9Br68A 提取码: v9uj
verdor: https://pan.baidu.com/s/1JDFgn0ywJR0zPsBFnZGBJg 提取码: kfdc
system: https://pan.baidu.com/s/1KQzvpMAzcHeOWq3bfl_YRw 提取码: 9ssi
apex: https://pan.baidu.com/s/19nMIHiBjzk1y18lBCxLA4Q 提取码: kce7
内核符号：https://gedu.oss-cn-beijing.aliyuncs.com/android/wucheng3/vmlinux

下载内核源代码：https://gedu.oss-cn-beijing.aliyuncs.com/android/wucheng3/kernel.tar.gz
## 历史版本
言子-虞城版本（2022年1月初始版本)
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/gdk860_yucheng.7z

# 三、更新方法

## 1. 单独更新U-BOOT
GDK8的UBOOT保存在单独的分区中，可以通过DD命令进行快速更新，但执行dd命令千万要谨慎， 不要把关键的位置和大小参数弄错，可以参考WiKi文章： 烧录镜像文件

更新命令如下：
```shell
od -c file | more
烧录前需要确认镜像文件与分区是否一致（确认第一行即可）。
dd if=uboot.img of=/dev/mmcblk$(X)p1 seek=0  //这里的分区需要以实际机器显示的结果为主，一般是xxp1分区
img_path：待烧录镜像文件的位置；对于内核文件而言，对应的文件为uboot.img。
/dev/mmcblk1p1：GDK8的U-BOOT一般在mmcblk1p1分区内；烧录前应进行确认。
```
## 2. 单独更新内核文件
GDK8的内核文件也是保存在单独的分区中，可以通过DD命令进行快速更新，执行dd命令千万要谨慎，不要把位置和大小参数弄错, 可以参考WiKi文章：烧录镜像文件

更新命令如下：
```shell
od -c file | more
烧录前需要确认镜像文件与分区是否一致（确认第一行即可）。
dd if=boot.img of=/dev/mmcblk$(X)p4 seek=0        //这里的分区需要以实际机器显示的结果为主，一般是xxp4分区
img_path：待烧录镜像文件的位置；对于内核文件而言，对应的文件为boot.img，并非kernel.img。
/dev/mmcblk1p4：GDK8的内核文件一般在mmcblk1p4分区内；烧录前应进行确认。
```

**$(X)：可以通过`ls /dev/`进行查看，比如`/dev/mmcblk2`，那么就对应`dd if=img_path of=/dev/mmcblk2p4 seek=0`**

## 3. 更新整个系统镜像
注意：这样更新将会擦写整个外存，外存上的所有文件将丢失，所以一定要在更新前做好备份!!!
更新时需要使用USB电缆将GDK8与主机相连，详细步骤请见WiKi文章： https://www.nanocode.cn/wiki/docs/gdk8_primer/primer_gdk8_firmware