# 使用GDK8烧录固件
欢迎进入 GDK8 的世界，本篇文章将会教大家来配置烧录环境和进行固件的烧录。
# 别插电源！别插电源！别插电源！USB线供电
## 基本模式介绍
Normal 模式：正常的启动模式，这个模式无法烧录固件。
烧录固件一共有两种方式，分别是在 Loader 模式下进行固件的烧录，另一种则是在MaskRom 模式下进行固件的烧录；关于两种模式的具体介绍见下方。
Loader 模式：用于烧录固件；按住 recover 按键再通电，通过 bootloader/uboot 的检测进入 loader 模式。
MaskRom 模式：功能与 loader 模式相同，通常在无法进入 loader 模式时使用；需要通过在板子上找对应的 EMMC_CLKO、GND 焊点。
在下面我会主要介绍 Loader 模式下固件烧录的方法，在文章的最后，会介绍如何进入MaskRom 模式进行烧录。 
## Loader 模式烧录的主要步骤
1. 准备 1 台GDK8、1 台主机[ 本机为 Windows 10 ]、镜像文件、烧录线缆及烧录工具镜像文件：可以自己进行制作，也可以使用下方的镜像文件。
下载链接： https://www.nanocode.cn/wiki/docs/gdk8_primer/gdk8_img_bom
烧录工具：从下方的链接中进行下载。
下载链接： https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Burn/FactoryTool_1.72.2-DriverAssitant_v5.1.1.rar
2. 当烧录工具下载完成后，首先需要解开压缩包，然后进入DriverAssitant_v5.1.1 目录，并运行 DriverInstall.exe，点击驱动安装，等待驱动完成安装；如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66dde29dd621b.jpg)
3. 进入 FactoryTool 目录，运行 FactoryTool.exe，如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66de2dfcb67f6.jpg)
4. 将 GDK8 与主机进行连接。
- 拿出 USB 2.0 电缆，将电缆一端插入 GDK8 左侧面板的 USB 2.0 接口中。
- 拿牙签（或与牙签相同粗细的物品亦可），桶入音频 av 接口，往下一按，你会发现有一个玄妙的小按钮藏在里面；如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66de662042c30.jpg)
- 持续按住小按钮 3 秒后（不松开小按钮），将电缆的另一端插入主机的任一 USB 2.0 接口（USB 3.0接口亦可，但要保证GDK8端插入的是USB 2.0接口）当中（不松开小按钮）；此时你会发现工厂工具已经将设备识别出来了（如果没有立刻识别出来，请继续保持小按钮被按住3秒后松开，然后等待10秒，查看期间是出现识别的情况）！如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66dec100543a0.jpg)
**注意：如果无法识别出机器可以多试几次或更换USB 2.0 接口进行尝试。**
5. 点击固件，选取合适的镜像，然后等待镜像完成加载。
6. 点击启动后，就开始进行固件的烧录了；只要等待镜像完成烧录即可；如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66defdfd33ab2.jpg)
**注意：假如烧录失败后无法进入loader 模式，则应先将 GDK8 开机一次（一次不行可以多试几次）；如果实在是不行，则应进入MaskRom 模式进行刷机（见后面）。**
7. 完成烧录后，点击停止，拔出 GDK8 即可；如下图所示。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66df4039a362b.jpg)
8. 这时就可以使用“新“的机器了，开机启动即可。

## 进入 MaskRom 模式
**注意：需要在Loader模式不能使用的情况下，再去使用MaskRom模式。**
1. 首先需要将 GDK8 背部的 4 个“小按钮”揭开，然后拧下螺丝，，拆开GDK8 的后面板。
2. 将烧录线缆一端插入 GDK8 的 USB 2.0 接口当中。
3. 根据下图找到 EMMC_CLKO、GND 焊点，并用电线 / 小镊子等物品，将两点接起来。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66df87b0dc4cc.jpg)
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66dff738eaac7.png)
4. 将烧录线缆另一端插入主机的 USB 2.0 接口当中，此时工厂工具就可以把设备识别出来，剩下的步骤与Loader 模式下相同，就不做过多介绍了。