# 使用遥控器控制GDK8
## 1. 功能说明
### 1.1显示IP地址
F1：显示IP地址的前两位数字（16进制）
F2：显示IP地址的后两位数字（16进制）

例：192.168.8.108
F1：C0 A8
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_01a9e064ee7ba5ad4eaf90d1eed3c464_r.jpg)
F2：08 6C
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_d00e5a120c4f0b7b149610ce340ea2a1_r.jpg)

## LED提示
使用遥控器切换状态后，LED显示切换功能及其当前状态。
LED前两位为切换功能提示，后两位为当前状态提示。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_8c6550f1c4517acea6eae3633cfa85ce_r.jpg)
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_53364ac05f0e42176e3890c3bd6d2892_r.jpg)
### 1.2 设置USB-2.0端口状态
F3：切换端口模式为OTG / Host
USB设备分为Host主设备和SLAVE从设备，只有当主设备和从设备连接时，才可以实现数据的传输。
Host：只能当作主设备使用
OTG：既可以当作主设备，有可以当作从设备

### 1.3设置SysRq状态
F4：打开 / 关闭SysRq
SysRq：一种内核调试的方法，只要内核还可以响应中断，SysRq就一直可以使用。
### 1.4 设置MircoSD插槽状态
F5：切换信号为JTAG / SD
JTAG：主要用于芯片内部测试及对系统进行仿真、调试， JTAG技术是一种嵌入式调试技术，它在芯片内部封装了专门的测试电路 TAP，通过专用的JTAG测试工具对内部节点进行测试。
### 1.5 自定义按键表
|   | 1*Fn | 2*Fn | 3*Fn | 4*Fn | 5Fn |
| ------------ | ------------ | ------------ | ------------ | ------------ | ------------ |
| 1 | F1  | a | k | u    | sysrq     |
| 2 | F2  | b | l | v    | 大小写转换 |
| 3 | F3  | c | m | w    | Tape      |
| 4 | F4  | d | n | x    | =         |
| 5 | F5  | e | o | y    | ,         |
| 6 | F6  | f | p | z    | Tab       |
| 7 | F7  | g | q | 空格 | $         |
| 8 | F8  | h | r | /    | (         |
| 9 | F9  | i | s | .    | )         |
| 0 | F10 | j | t |-     | ;         |

## 2. 遥控器按键设置原理
如果想要了解遥控器的按键是如何进行设置的，请查看文章[设置遥控器按键](https://www.nanocode.cn/wiki/docs/gdk8_primer/gdk8_set_remotectl "设置遥控器按键")。

# 更新脚本
下载地址：https://gedu.oss-cn-beijing.aliyuncs.com/gird_gourdboy/gd_gg.sh

# 下载链接：
版本1.1：https://gedu.oss-cn-beijing.aliyuncs.com/gird_gourdboy/version_1.1.7z