欢迎使用 Nanocode 调试工具！本教程将指导您如何使用 Nanocode 图形界面或 ndb 命令行来调试您的 Gdk8 内核。

# 环境要求：
- 当前Nanocode的Linux版仅支持双剑系统，秀峰系统用户可以升级为双剑后体验Nanocde.
- 幽兰代码本（#1.0.8-ShuangJian2-Release SMP Mon Apr 15 11:54:40 CST 2024）
- Nanocode (版本号2.7.6）
- Gdk8（4.19.161-yanzi #50 SMP PREEMPT Fri Aug 25 14:37:40 CST 2023）

其中Nanocde安装方法可以点击下面链接查看
https://www.nanocode.cn/wiki/docs/youlan/nanocode_linux
# 1. 使用Nanocode图形界面调试Gdk8
1. 打开 Nanocode 并选择 Nano Debugger 左侧选项。
2. 在 DEBUG 栏中选择内核调试，并在弹出的窗口中选择 OpenOCD。
3. 输入 "gdk8" 并设置相关参数（如下图所示），然后点击启动按钮。
4. 调试成功后，这时候可以点击中断按钮，以暂停 Gdk8，并在 "kd>" 栏中输入命令来调试。

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_388597825d1a75be1febccba6b04cc4c_r.png)

![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_b7492ebccabeae9f07b682c15c24a56a_r.png)
首次我们需要设置Gdk8的符号以及代码路径。可以参考Windows版下载[Nanocode Windows版](https://www.nanocode.cn/wiki/docs/gdk8_primer/gdk8_primer-1espn4ktqfuf1 "Nanocode Windows版")
例如：我这里将下载好的符号文件放到了symbol目录
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_75679f557dfcd9fb9423d03958bd1a07_r.png)
那我就可以在Nanocode的命令行内输入：
```bash
.sympath /home/geduer/gdk8/symbol
```
同理，相关代码我这里放到了source目录
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_7a92e0adf767694262510fd675f5c5ff_r.png)
那我设置代码路径命令为：
```bash
.srcpath /home/geduer/gdk8/source
```
然后输入.reload命令重新加载
```bash
.reload
```
.reload后如果顺利则可以看到源代码窗口自动弹出，此时即可对照着源代码进行内核调试
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_eb2037f526a56a265103b22f7e760fa9_r.png)

# 2. 使用ndb命令行调试
ndb的位置在/usr/share/nanocode目录下。
输入/usr/share/nanocode/ndb -?可以查看使用帮助
```bash
/usr/share/nanocode/ndb -?
```
例如，Gdk8命令如下：
```bash
./ndb -t gdk8 -m -l -hw
```
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_b80c1aa995fb2437a852849d3427bed4_r.png)
然后可以看到enter 'b' to breakin.这时候按键盘B键位回车即可中断下来
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_5e4ef888e0fbef5ff3ff23aed69eaa3b_r.png)
ndb命令行使用的相关命令和Nanocode图形化命令一样，如下图
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_e9c993971724174bd21abfc0ebcc554a_r.png)