# 玩转GDK8之远程桌面
1.	使用MobaXterm连接GDK8或者在GDK8上打开一个控制台窗口，执行如下命令安装x11vnc。
```c
sudo apt-get update
sudo apt-get install x11vnc net-tools
```
2.	设置密码。
`x11vnc -storepasswd`
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_64fbd7fc3d4cc73f4a5e73eff5a40241_r.png)
3.	启动x11vnc的服务。
```c
sudo /usr/bin/x11vnc -display :0 -auth /var/run/lightdm/root/:0 -forever -bg -o /var/log/x11vnc.log -rfbauth /etc/x11vnc.pass -rfbport 5900
```
4.	执行如下命令，确认x11vnc进程已经在后台运行。
`ps -aux | grep vnc`
应该看到x11vnc进程
5.	复制密码文件。
`sudo cp /home/geduer/.vnc/passwd /etc/x11vnc.pass`
6.	在PC上，安装客户端，比如RealVnc Viewer。
https://www.realvnc.com/en/connect/download/viewer/ 
7.	在RealVnc中输入gdk的IP地址，比如192.168.3.61，按回车发起连接。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_54da3978f5d924cc52efede22523f089_r.png)
如果成功建立通信，vnc viewer可能显示如下提示对话框。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_df9fec6de30ad1f10935a2baf1f5d0d3_r.png)
选中不再提示，点击继续，就可以看到gdk8的桌面了。
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_944b507c52e6a0ca09c1ddc5841b414a_r.png)
8.	安装为服务，自动启动，将以下内容保存为vnc.sh, chmod +x vnc.sh增加执行权限，然后以sudo方式执行这个脚本

```shell
#!/bin/bash
#install x11vnc & set password
apt-get install x11vnc -y
x11vnc -storepasswd 123456 /etc/x11vnc.pass
#create config file for  system service
cat > /lib/systemd/system/x11vnc.service <<-EOF
[Unit]
Description="x11vnc"
Requires=display-manager.service
After=display-manager.service

[Service]
 ExecStart=/usr/bin/x11vnc -xkb -noxrecord -noxfixes -noxdamage -display :0 -auth guess -rfbauth /etc/x11vnc.pass
ExecStop=/usr/bin/killall x11vnc

[Install]
WantedBy=multi-user.target
EOF
#restart new services &  enable on boot
systemctl daemon-reload
systemctl start x11vnc
systemctl enable x11vnc
```
https://askubuntu.com/questions/229989/how-to-setup-x11vnc-to-access-with-graphical-login-screen/
【下面的方法可能导致系统无法进入桌面，先不要尝试】
9.	放入启动脚本
`sudo vi /etc/init/x11vnc.conf`
按i键进入插入模式，如何粘贴如下内容到文件。
```shell
start on login-session-start
script
x11vnc -display :0 -auth /var/run/lightdm/root/:0 -forever -bg -o /var/log/x11vnc.log -rfbauth /etc/x11vnc.pass -rfbport 5900
end script
```
按ESC键，输入wq命令保存并退出。
```shell
XIO:  fatal IO error 11 (Resource temporarily unavailable) on X server ":0"
  after 7407 requests (7407 known processed) with 0 events remaining.
```
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_d7204c76205e6c80e43bedae009e10e6_r.png)