# GDK8上手指南
## 欢迎您使用GDK8!
GDK8（GEDU Development Kit 8）是格蠹科技针对ARMv8架构研发的开发和调试平台，预装了GNU的开发工具链，是学习和研究ARMv8架构、LINUX操作系统和嵌入式软件技术的有力助手。您收到的盒子中包括以下硬件部件：
- GDK8主机	1台
- 交流转直流电源适配器	1台
- HDMI电缆	1根

## 预装软件
Ubuntu系统，64位，版本为18.04
Nano Debugger目标机模块，用于支持符号化的Linux应用程序调试

## 主机硬件配置：
- 主芯片为RK3328 SoC，集成有4个A53 CPU和Mali-450MP4 GPU 
- 4G内存
- 128G EMMC闪存
- WIFI无线网卡
- 集成在主板上的有线网卡

![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66a855539381b.png)

## 外部接口
GDK8的外部面板具有如下接口：
- 1个RJ45网口
- 1个Type A USB 2.0端口
- 1个 Type A USB 3.0端口
- 1个语音输入和输出接口
- 1个HDMI显示接口
- Micro SD卡读卡器接口

## 内部接口
GDK8的机箱内部具有如下接口：
- RS232串口

## 开机步骤：
1. 使用HDMI线连接显示器。
2. 请连接一个鼠标到GDK8，因为系统里预装了软键盘，所以可以暂时不接键盘硬件。
3. 插上电源，插上电源后，系统便自动开机，前面板的LED灯会被点亮。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66adab8d405a7.png)
4. 当系统起到到桌面后，建议为其联网，如果使用无线网络，那么请点击屏幕右上方的无线图标，选择无线AP，如果需要输入密码，那么可以点击桌面上的Onboard图标，调出软键盘进行输入。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66b64e4a6d0a4.png)
5. 成功连接网络后，请点击屏幕左上方的控制台图标，打开控制台窗口，输入ifconfig命令并按回车执行，转到IP地址，并将其记录下来。
6. 建议下载MobaXterm软件到您的PC，安装后建立一个SSH连接（用户名和密码见后文），这样就可以在PC上来使用GDK8了。
https://mobaxterm.mobatek.net/download-home-edition.html 
7. 如果使用有线连接，而且有路由器，那么只要用网线将GDK8连接到路由器即可。
8. 如果没有路由器，那么可以用一根网线将GDK8与PC直接连接，然后先在PC端的Windows系统中按如下顺序操作：
右下角托盘区域点右键，打开“网络和Internet设置”>以太网>更改适配器选项>找到以太网图标，点右键选属性>TCP/IPv4>
IP地址: 192.168.1.3
子网掩码: 255.255.255.0
默认网关: 192.168.1.1
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66b5d36a6e01a.png)
9. 然后再在GDK8上点右下角的网络图标 > Wired Connection 1 > 点击像太阳似的设置按钮 > IPv4 Settings，Method下拉框选Manual，然后在地址列表里增加：
Address: 192.168.1.2 
Netmask: 24
Gateway: 192.168.1.1

## 开始调试
1. 为GDK8配置网络后，执行ifconfig命令，观察GDK8的IP地址，并将这个地址记录下来。
2. 在主机端通过如下连接下载Nano Code软件，并进行安装，安装时使用默认选项即可。
https://www.nanocode.cn/#/download 
3. 启动Nano Code，点击登录按钮注册一个新用户，如果已经注册过，则可以直接登录。
4. 点击Nano菜单，选择Debugger，唤出Nano Debugger的操作界面。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66b901641d739.png)
5. 点击文件菜单，选择“连接到远端”，在弹出的对话框中输入如下连接串：
tcp:port=2021,server=<GDK8的IP地址>
![](https://www.nanocode.cn/wiki/uploads/gdk8_primer/images/m_af8411a14fbae63a4b088a96a2c4867d_r.png)
6. 输入好连接串后，点击“连接”按钮，如果连接失败，Nano Debugger会显示“远程连接失败”，如果没有显示，则代表连接成功。
7. 点击Nano Debugger的文件菜单，选择“打开执行文件”，在接下来的对话框中，在机器一栏选择刚刚连接的GDK8，然后在命令行一栏输入要调试程序的全路径。
8. 所有信息填写好后，点击“开始”按钮，Nano Debugger便会通过网络连接与GDK8上ndstub进程通信，进行远程调试了。
9. 如果调试时遇到意外情况，建议点击View > Output唤出Output面板，在面板上的信息源下拉框中选择“Nano Code”。
![](https://www.nanocode.cn/wiki/uploads/blog/202111/attach_16b66bcced3fcf73.png)

## 特别提醒：
- Ubuntu系统默认用户名为geduer，密码为gd2021，请及早修改密码
- GDK8是为专业开发者学习和研究使用，某些设置削弱了系统的安全性和稳定性，请不要把GDK8当作办公和家庭电脑使用

## 联系我们：
邮箱：lisa.long@nanocode.cn
GDK8官网：https://nanocode.cn/#/gdk8  
软件工具官网：https://www.nanocode.cn 
格蠹信息科技（上海）有限公司